import Deferred from '../src/Deferred';
type Condition = Partial<{
    method: string;
    url: string;
    params: {
        [id: string]: any;
    };
    getAttribute: (arg0: string) => any;
}>;
declare class MockXhr {
    header: Array<any>;
    xhr: null | XMLHttpRequest;
    method: null | string;
    pending: Deferred<any>;
    constructor();
    get(condition: Condition): {
        context: MockXhr;
        abort: () => void;
        resolve: (fakeResult: any, delay?: number) => void;
        reject: (fakeResult: any, delay?: number) => void;
    };
    post(condition: Condition): {
        context: MockXhr;
        abort: () => void;
        resolve: (fakeResult: any, delay?: number) => void;
        reject: (fakeResult: any, delay?: number) => void;
    };
    delete(condition: Condition): {
        context: MockXhr;
        abort: () => void;
        resolve: (fakeResult: any, delay?: number) => void;
        reject: (fakeResult: any, delay?: number) => void;
    };
    put(condition: Condition): {
        context: MockXhr;
        abort: () => void;
        resolve: (fakeResult: any, delay?: number) => void;
        reject: (fakeResult: any, delay?: number) => void;
    };
    sendForm(form: Condition): {
        context: MockXhr;
        abort: () => void;
        resolve: (fakeResult: any, delay?: number) => void;
        reject: (fakeResult: any, delay?: number) => void;
    };
    abort(fakeResult: any): void;
    resolve(fakeResult: any, delay?: number): void;
    reject(fakeResult: any, delay?: number): void;
    static restore(): void;
    _mockXMLHttpRequest(this: MockXhr, condition: Condition): {
        context: MockXhr;
        abort: () => void;
        resolve: (fakeResult: any, delay?: number) => void;
        reject: (fakeResult: any, delay?: number) => void;
    };
}
export default function mockXhr(): {
    get(condition: Condition): {
        context: MockXhr;
        abort: () => void;
        resolve: (fakeResult: any, delay?: number) => void;
        reject: (fakeResult: any, delay?: number) => void;
    };
    post(condition: Condition): {
        context: MockXhr;
        abort: () => void;
        resolve: (fakeResult: any, delay?: number) => void;
        reject: (fakeResult: any, delay?: number) => void;
    };
    delete(condition: Condition): {
        context: MockXhr;
        abort: () => void;
        resolve: (fakeResult: any, delay?: number) => void;
        reject: (fakeResult: any, delay?: number) => void;
    };
    put(condition: Condition): {
        context: MockXhr;
        abort: () => void;
        resolve: (fakeResult: any, delay?: number) => void;
        reject: (fakeResult: any, delay?: number) => void;
    };
    sendForm(condition: Condition): {
        context: MockXhr;
        abort: () => void;
        resolve: (fakeResult: any, delay?: number) => void;
        reject: (fakeResult: any, delay?: number) => void;
    };
    restore(): void;
};
export {};
