import type { ComputedRef, Ref, UnwrapRef } from 'vue';
import type { RequiredParams, TypeAllowed, UnwrappedPromiseType } from './index';
type OnErrorCb<T> = (e: null | Error, params: T) => void;
type OnStartCb<T> = (params: T) => void;
type OnEndCb<T, Z> = (res: T, params: Z) => void;
declare const useAsync: <T, Z extends TypeAllowed, A extends TypeAllowed[], F extends ((...args: A) => Promise<T>) | ((args: Z) => Promise<T>), P extends RequiredParams<Parameters<F>[0], A>>(func: ((...args: A) => Promise<T>) | ((args: Z) => Promise<T>), params?: P, enabled?: Ref<boolean> | (() => boolean)) => {
    isPending: Ref<undefined | boolean>;
    data: ComputedRef<undefined | null | UnwrappedPromiseType<F>>;
    error: Ref<null | Error>;
    reload: () => void;
    onError: (cb: OnErrorCb<P extends () => infer PP ? PP : (P extends ComputedRef<unknown> ? UnwrapRef<P> : P)>) => void;
    onStart: (cb: OnStartCb<P extends () => infer PP ? PP : (P extends ComputedRef<unknown> ? UnwrapRef<P> : P)>) => void;
    onEnd: (cb: OnEndCb<UnwrappedPromiseType<F>, P extends () => infer PP ? PP : (P extends ComputedRef<unknown> ? UnwrapRef<P> : P)>) => unknown;
    promise: ComputedRef<null | Promise<T>>;
};
export default useAsync;
