import { ComputedRef, Ref } from 'vue';
import type { Obj, UnwrappedPromiseType } from './index';
type TypeAllowed = undefined | boolean | null | string | number | Obj;
type OnErrorCb<Z, A extends TypeAllowed[]> = (e: null | Error, params: A extends [] ? Z : [Z, ...A]) => unknown;
type OnEndCb<T, Z, A extends TypeAllowed[]> = (res: T, params: A extends [] ? Z : [Z, ...A]) => unknown;
export default function useMutation<T, Z extends TypeAllowed, A extends TypeAllowed[]>(func: (arg: Z, ...args: A) => Promise<T>): {
    mutate: (param?: Z, ...restParams: A) => Promise<UnwrappedPromiseType<typeof func>>;
    onError: (cb: OnErrorCb<Z, A>) => unknown;
    onEnd: (cb: OnEndCb<UnwrappedPromiseType<typeof func>, Z, A>) => unknown;
    isPending: Ref<boolean>;
    error: Ref<null | Error>;
    data: Ref<UnwrappedPromiseType<typeof func>>;
    promise: ComputedRef<null | Promise<T>>;
};
export {};
