import { Ref } from 'vue';
type NonNullable<T> = Exclude<T, null | undefined>;
type Res<T, Z extends T> = NonNullable<Z extends never[] ? T : Z>;
export declare class Result<T> {
    constructor(v: T);
    value: T;
    uuid: string;
}
export default function <T, Z extends T, U = Res<T, Z>>(input: Ref<T>, defaultRes: NonNullable<Z>, map?: (r: Res<T, Z>) => NonNullable<U>): Ref<U>;
export {};
