import type { ComputedRef, Ref } from 'vue';
import type { $UpdateConfigArgs, GetConfig, GetReturn, RequiredParams, TypeAllowed } from './index';
import Xhr from './Xhr';
type Enabled = undefined | null | (() => boolean) | Ref<boolean> | ComputedRef<boolean> | boolean;
type Token = Ref<string | null> | ComputedRef<string | null> | string | null;
type OnErrorCb<T> = (e: Error, xhr: Xhr<T>) => unknown;
type OnStartCb<T, Z> = (params: Z, xhr: Xhr<T>) => unknown;
type OnEndCb<T, Z> = (res: T, params: Z, xhr: Xhr<T>) => unknown;
declare type UseXhr<T, Z extends TypeAllowed, A extends TypeAllowed[], F extends ((...args: A) => Promise<T>) | ((args: Z) => Promise<T>), P extends RequiredParams<Parameters<F>[0], A>> = Partial<{
    onError: (cb: OnErrorCb<P>) => unknown;
    onStart: OnStartCb<T, P>;
    onEnd: OnEndCb<T, P>;
    onProgress: (e: ProgressEvent) => any;
    onAbort: (e: ProgressEvent) => any;
    context: any;
    legacy: boolean;
    token: Token;
}>;
export default function <T, Z extends TypeAllowed, A extends TypeAllowed[], F extends ((..._args: A) => Promise<T>) | ((_args: Z) => Promise<T>), P extends RequiredParams<Parameters<F>[0], A>>(args?: UseXhr<T, Z, A, F, P>): {
    get: <TT = T, ZZ extends TypeAllowed = Z, AA extends TypeAllowed[] = A>(parametersObj: GetConfig<ZZ>, params?: RequiredParams<ZZ, AA>, enabled?: Enabled) => GetReturn<TT>;
    post: <TT = T, ZZ extends TypeAllowed = Z, AA extends TypeAllowed[] = A>(xhrConfig?: $UpdateConfigArgs, params?: RequiredParams<ZZ, AA>) => {
        xhr: Xhr<TT>;
        isPending: Ref<undefined | boolean>;
        data: ComputedRef<TT | null | undefined>;
        error: Ref<null | Error>;
        reload: () => void;
        onError: (cb: (e: null | Error, params: [] | TypeAllowed | Ref<[] | TypeAllowed, [] | TypeAllowed>) => void) => void;
        onStart: (cb: (params: [] | TypeAllowed | Ref<[] | TypeAllowed, [] | TypeAllowed>) => void) => void;
        onEnd: (cb: (res: TT, params: [] | TypeAllowed | Ref<[] | TypeAllowed, [] | TypeAllowed>) => void) => unknown;
        promise: ComputedRef<Promise<TT> | null>;
    };
    put: <TT = T, ZZ extends TypeAllowed = Z, AA extends TypeAllowed[] = A>(xhrConfig?: $UpdateConfigArgs, params?: RequiredParams<ZZ, AA>) => {
        xhr: Xhr<TT>;
        isPending: Ref<undefined | boolean>;
        data: ComputedRef<TT | null | undefined>;
        error: Ref<null | Error>;
        reload: () => void;
        onError: (cb: (e: null | Error, params: [] | TypeAllowed | Ref<[] | TypeAllowed, [] | TypeAllowed>) => void) => void;
        onStart: (cb: (params: [] | TypeAllowed | Ref<[] | TypeAllowed, [] | TypeAllowed>) => void) => void;
        onEnd: (cb: (res: TT, params: [] | TypeAllowed | Ref<[] | TypeAllowed, [] | TypeAllowed>) => void) => unknown;
        promise: ComputedRef<Promise<TT> | null>;
    };
    delete: <TT = T, ZZ extends TypeAllowed = Z, AA extends TypeAllowed[] = A>(xhrConfig?: $UpdateConfigArgs, params?: RequiredParams<ZZ, AA>) => {
        xhr: Xhr<TT>;
        isPending: Ref<undefined | boolean>;
        data: ComputedRef<TT | null | undefined>;
        error: Ref<null | Error>;
        reload: () => void;
        onError: (cb: (e: null | Error, params: [] | TypeAllowed | Ref<[] | TypeAllowed, [] | TypeAllowed>) => void) => void;
        onStart: (cb: (params: [] | TypeAllowed | Ref<[] | TypeAllowed, [] | TypeAllowed>) => void) => void;
        onEnd: (cb: (res: TT, params: [] | TypeAllowed | Ref<[] | TypeAllowed, [] | TypeAllowed>) => void) => unknown;
        promise: ComputedRef<Promise<TT> | null>;
    };
};
export {};
